//
//  AppDelegate.swift
//  FileProgressExample
//
//  Created by Michail Ovchinnikov on 08.05.18.
//  Copyright © 2018 Michail Ovchinnikov. All rights reserved.
//

import Cocoa

@NSApplicationMain
class AppDelegate: NSObject, NSApplicationDelegate {

    @IBOutlet weak var window: NSWindow!


    func applicationDidFinishLaunching(_ aNotification: Notification) {
        // Insert code here to initialize your application
        try! setProgress(value: 0.6, forFile: "/Users/a14428108/1.txt")
    }

    func applicationWillTerminate(_ aNotification: Notification) {
        // Insert code here to tear down your application
    }
    
    func setProgress(value: Double, forFile path: String) throws {
        var fileAttributes = try FileManager.default.attributesOfItem(atPath: path)
        let extendedAttributesKey = FileAttributeKey(rawValue: "NSFileExtendedAttributes")
        var extendedAttributes = fileAttributes[extendedAttributesKey] as? Dictionary ?? [:]
        let progressData = "\(value)".data(using: .ascii)
        extendedAttributes["com.apple.progress.fractionCompleted"] = progressData
        fileAttributes[extendedAttributesKey] = extendedAttributes
        
        let dateString = "1984-01-24 08:00:00 +0000"
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "YYYY-MM-dd HH:mm:ss Z"
        let date = dateFormatter.date(from: dateString)
        fileAttributes[FileAttributeKey.creationDate] = date

        try FileManager.default.setAttributes(fileAttributes, ofItemAtPath: path)
    }

}

